/* aint_types.h
 * Type definitions used in aint
 */

#ifndef AINT_TYPES_H
#define AINT_TYPES_H


#include <sys/types.h>
#include "aint_consts.h"

typedef class icode *icode_ptr;
typedef class process *process_ptr;
typedef class thread *thread_ptr;
typedef class path *path_ptr;
typedef class inflight_inst *inflight_inst_ptr;
typedef class icode *icode_ptr;

// typedef icode_ptr (*PFPI)(inflight_inst_ptr, icode_ptr, path_ptr, thread_ptr);

typedef icode_ptr (iaction)(inflight_inst_ptr, icode_ptr, path_ptr, thread_ptr);
typedef iaction *iaction_ptr;

// typedef icode_ptr (*iaction_ptr)(inflight_inst_ptr, icode_ptr, path_ptr, thread_ptr);

// typedef enum {BB_INNER=0, BB_FIRST=1, BB_LAST=2, BB_SOLE=3} bbcode_t;

typedef enum {RA=0, RB, RC, MaxArgs} Arg;

typedef union {
  long Int64;
  double Double;
} RegType;
typedef double FPRegType;
typedef short Logical_RegNum;
typedef short Physical_RegNum;

typedef ulong pathid_t;

typedef ulong aint_addr_t;
typedef ushort aint_logical;
typedef unsigned int aint_instr_t;

typedef unsigned long aint_time_t;

/* op function pointer */
typedef icode_ptr (*op_fptr)(inflight_inst_ptr, icode_ptr, path_ptr, thread_ptr);


typedef enum {
  R_RUN = 0,
  R_SLEEP,
  R_STALL,
  R_BLOCK,
  R_WAIT,
  R_ZOMBIE,
  R_DONE,
  R_FREE,
  R_STOPPED, /* by ptrace() equivalent */
  R_SIGNAL,
  R_SINGLESTEP,
  R_MAX
} state_t;

typedef enum Kill_Type_e { KT_mispredict=0, KT_trap } Kill_Type;

#endif
