/* reg.h
 * constants and inline functions pertaining to the register file
 */

#ifndef AINT_REG_H
#define AINT_REG_H

const int ZERO_REGISTER = 31;

# define ZERO_ZERO_REG (pthread->Reg[ZERO_REGISTER].Int64=0)
# define ZERO_ZERO_FP (pthread->Reg[ZERO_REGISTER].Double=0)

const Logical_RegNum GP = 29;
const Logical_RegNum SP = 30;

const Logical_RegNum A0 = 16;
const Logical_RegNum A1 = 17;
const Logical_RegNum A2 = 18;
const Logical_RegNum A3 = 19;
const Logical_RegNum A4 = 20;
const Logical_RegNum A5 = 21;

const Logical_RegNum RET_VAL_REG = 0;
const Logical_RegNum ERRNO_REG = 19; // from syscalls
const Logical_RegNum CHILD_FLAG_REG = 20; // from fork
const Logical_RegNum PROCEDURE_VALUE_REG = 27;

inline Logical_RegNum
FP_REDIRECT(Logical_RegNum lfp) { return lfp + N_Logical_Regs; }

inline Logical_RegNum
FP_REDIRECT_Z(Logical_RegNum lfp) { return (lfp == ZERO_REGISTER) ? lfp : lfp + N_Logical_Regs; }




#endif
