#ifndef AINT_PTHREAD_H
#define AINT_PTHREAD_H

/* Header file for "fake" pthreads */

/* Include the syscall number definitions */
#include <aint_syscall.h>

/* This defines the interface to DU 4.0-like pthreads (POSIX 1003.1c-1995) */

typedef void * pthread_t;
typedef void * pthread_attr_t;
typedef unsigned int pthread_key_t;

#ifndef PTHREAD_KEYS_MAX
# define PTHREAD_KEYS_MAX               255
#endif

int pthread_create(pthread_t *, const pthread_attr_t *, void * (*)(void *), void *);

int pthread_join(pthread_t, void **);

int pthread_exit(void *);

int pthread_key_create(pthread_key_t *key, void (*destructor)(void *));

void * pthread_getspecific (pthread_key_t key);

int pthread_setspecific (pthread_key_t key, const void *value);

#endif
