
/* mmsp.c: float matrix multiply */

/* #define N 256 */

#include <stdio.h>

int main(int argc, char *argv[])
{
  float *A, *B, *C;
  int i, j, k, seed, N; 
  double s;

  fprintf(stderr,"usage: mmsp <size> <seed>\n");
  sscanf(argv[1], "%d", &N);
  sscanf(argv[2], "%d", &seed);

  srandom(seed);

  A = (float *) malloc(N*N*sizeof(float));
  B = (float *) malloc(N*N*sizeof(float));
  C = (float *) malloc(N*N*sizeof(float));
  
  /* First create the matrices A and B */
  for (i=0; i<N; i++) for (j=0; j<N; j++) {
    A[i*N + j] = ((float)random())/( (float)random());
    B[i*N + j] = ((float)random())/( (float)random());
  }

  /* Multiply */
  for (i=0; i<N; i++) for (j=0; j<N; j++) {
    s = 0.0;
    for (k=0; k<N; k++) s += A[i*N + k]*B[k*N + j];
    C[i*N + j] = s;
  }

  s = 0;
  for (i=0; i<N; i++) for (j=0; j<N; j++) {
    s += C[i*N + j];
  }

  printf("Sum of elements is %g\n", s);
}
