#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

int main()
{
  /* Allocate two shmem segments */
  key_t k1, k2;
  int shmid1, shmid2;
  int pid, status;
  char *seg1, *seg2;
  struct shmid_ds buf;

  k1 = ftok("/vmunix", 1);
  k2 = ftok("/vmunix", 2);

  shmid1 = shmget(k1, 256, IPC_CREAT|0666);
  shmid2 = shmget(k2, 256, IPC_CREAT|0666);

  /* Fork off and attach the two segments */
  pid = fork();

  seg1 = shmat(shmid1, 0, 0);  
  seg2 = shmat(shmid2, 0, 0);  

  /* Fill in garbage */
  if (pid) strncpy(seg1, "Hello!", 6); else
  strcpy(seg1+5, "World!");

  wait(&status);

  if (pid) {
    printf("Parent...\n");
    puts(seg1);
    fflush(stdout);
  }

}
  
